;XIncludeFile "\Bremer\PureBasicPbi\DebugMacros.pbi"

;diese Version untersttzt Konstanten als PBnr und #PB_Any
;der 1.Parameter ist jetzt eine laufende Nr., der zweite der Typ

;die Reihenfolge im Interface 
;und der zugehrigen DataSection mu gleich sein !!!

Interface IcStringGadget 
  Release() 
  PBnr()
  IDnr()
  Dezimal(a=0)
  TFormat()
  MaxChar(a)
  Helptext(a.s) 
  SelectAll() 
  Textfeld(a.s,b=0,c=2)
  X()
  Y()
  NextX()
  NextY()
  CursorPos(a)
  IsLast(a)
  IsFirst(a)
  
  ;interne Funktion
  SubClassPrc(a,b,c,d)  
  
  ;folgende Funktionen knnen auch durch PB Befehle ersetzt werden
  getText.s()
  setFont(a)
  setFocus()
  setFrontColor(a)
  setBackColor(a)
EndInterface 

Structure cStringGadget_intern
  first.i
  last.i
EndStructure

Structure cStringGadget 
  *VTable_cStringGadget
  *mem.cStringGadget_intern  
  typ.i              ;1=String, 2=Option, 3=Checkbox, 4=TextGadget
  x.i
  y.i
  br.i
  hh.i
  pbnr.i
  idnr.i
  oldproc.i          ;Adresse fr subclassing
  dezimal.i          ;Zahlenfeld mit Anzahl Dezimalstellen, darf null sein
  numbers.i          ;wird von dezimal gesetzt
  tformat.i          ;formatiert TausenderTrennzeichen
  maxchar.i          ;soviele Zeichen eingeben
  txt.s{222}         ;Gadgetinhalt intern
  txtlg.i            ;dessen Lnge
  infodezimal1.s{55} ;infos im Callback
  infodezimal2.s{55}
  infohelptext.s{55}
  nfmt.numberfmt     ;fr #WM_KILLFOCUS wenn \TFormat gesetzt ist
  komma.s{2}         ;fr nfmt.numberfmt
  punkt.s{2}         ;fr nfmt.numberfmt
  selectall.i        ;flag fr Callback
EndStructure 

Procedure.i IcStringGadget_BallonTip(hWnd, text$, icon=1, titel$="Information") 
;diese Structure gibt es in 4.30 nicht
;merkwrdigerweise aber #EM_SHOWBALLOONTIP
Structure EDITBALLOONTIP 
  cbStruct.l 
  pszTitle.l 
  pszText.l 
  ttiIcon.l 
EndStructure 

  Protected ebt.EDITBALLOONTIP , memtext , memtitel
      
  ;AnsiToUni
  SHStrDup_(@text$,@memtext) 
  SHStrDup_(@titel$,@memtitel) 
  
  ebt\cbStruct = SizeOf(ebt) 
  ebt\ttiIcon  = icon 
  ebt\pszText  = memtext 
  ebt\pszTitle = memtitel 
   
  SendMessage_(hWnd, #EM_SHOWBALLOONTIP, 0, @ebt)
  
  CoTaskMemFree_(ebt\pszText)
  CoTaskMemFree_(ebt\pszTitle)
    
EndProcedure 

Procedure.i IcStringGadget_SubClassPrc(hWnd, Msg, wParam, lParam) 
;hwnd ist hier gleich der ID vom Gadget
;CallWindowProc_ mu hier am Ende gesetzt werden
;sonst geht nix richtig, weil wParam gendert wird
    
Protected *this.cStringGadget = GetWindowLong_(hWnd,#GWL_USERDATA) 
Protected curpos, pktpos, anzdez, start, ende, buffer$

  If Msg = #WM_CHAR  ;258
  
     If *this\numbers   
        
        Select wParam
          Case 44: wparam = 46        ;Komma wird Punkt
          Case 48 To 57               ;Zahlen erlaubt
          Case #VK_BACK, #VK_RETURN   ;Backspace erlaubt
          Case #VK_ESCAPE
          Default: wparam = 0         ;alles andere unterbinden
                   IcStringGadget_BallonTip(hWnd, "erlaubt sind nur Zahlen")
        EndSelect
        
        ;keine Dezimalstellen, kein Punkt
        If *this\dezimal = 0
            If wparam = 46
               wparam = 0
               IcStringGadget_BallonTip(hWnd, *this\infodezimal1, 1)
            EndIf
        EndIf
        
        ;2 Punkte eingeben = nein
        If wparam = 46  
           If CountString(GetGadgetText(*this\pbnr), ".")
              wparam = 0
              IcStringGadget_BallonTip(hWnd, *this\infodezimal2, 2)
           EndIf
        EndIf
                
        ;Anzahl Dezimalstellen checken
        If *this\dezimal                    ;Dezimalstellen definiert ?
           *this\txt = GetGadgetText(*this\pbnr)
           *this\txtlg = SendMessage_(hwnd, #EM_LINELENGTH, 0, 0)
            If CountString(*this\txt, ".")             ;gibt es einen Punkt ?
               SendMessage_(hwnd,#EM_GETSEL,@curpos,0) ;wo ist der Cursor ?
               pktpos = FindString(*this\txt, ".", 1)  ;wo ist der Punkt ?
               anzdez = *this\txtlg - pktpos     ;len - pktpos = Dezimalstellen 
               If anzdez >= *this\dezimal        ;wenn Anzahl Dezimalstellen erreicht
                  If curpos >= pktpos            ;wenn Cursor hinterm punkt
                     Select wparam
                       Case #VK_BACK,#VK_RETURN  ;wenn Backspace 
                       Default                   ;sonst
                        wparam = 0               ;dann Eingabe = 0                       
                        IcStringGadget_BallonTip(hWnd, *this\infodezimal1, 3)
                     EndSelect
                  EndIf
               EndIf              
            EndIf
        EndIf
        
     EndIf  ;von IF *this\numbers
     
     ;max Lnge kontrollieren, wenn definiert 
     If *this\maxchar
        *this\txtlg = SendMessage_(hwnd, #EM_LINELENGTH, 0, 0)
         If *this\txtlg = *this\maxchar
             Select wparam 
                Case #VK_BACK, #VK_ESCAPE , #VK_RETURN
                Default: If *this\dezimal
                            IcStringGadget_BallonTip(hWnd, "max Lnge erreicht, Anzahl Dezimalstellen ok ?", 3)
                         Else
                            IcStringGadget_BallonTip(hWnd, "max Lnge erreicht", 3)
                         EndIf
             EndSelect   
         EndIf
     EndIf
            
  ElseIf Msg = #WM_KEYDOWN  ;256
         Select wparam
           Case 38: ;"Pfeil oben"
                ;Simuliert Shift+Tab Taste 
                If *this\mem\first <> hwnd                
                   keybd_event_(#VK_SHIFT, 0,0,0) 
                   keybd_event_(#VK_TAB,0,0,0) 
                   keybd_event_(#VK_TAB,0,#KEYEVENTF_KEYUP,0) 
                   keybd_event_(#VK_SHIFT,0,#KEYEVENTF_KEYUP,0) 
                EndIf   
           Case 40: ;"Pfeil unten"
                ;Simuliert Tab Taste 
                If *this\mem\last <> hwnd
                   keybd_event_(#VK_TAB,0,0,0) 
                   keybd_event_(#VK_TAB,0,#KEYEVENTF_KEYUP,0) 
                EndIf   
           Case 13: ;"Return"
                ;Simuliert Tab Taste 
                ;If *this\mem\last <> hwnd
                   keybd_event_(#VK_TAB,0,0,0) 
                   keybd_event_(#VK_TAB,0,#KEYEVENTF_KEYUP,0) 
                ;EndIf   
         EndSelect       
  
  ElseIf msg = #WM_HELP   ;83
         IcStringGadget_BallonTip(hWnd, *this\infohelptext, 1, "Hilfe")
  
  ElseIf msg = #WM_PASTE
         If *this\maxchar
            SendMessage_(hwnd,#EM_GETSEL,@start,@ende) 
            *this\txtlg = SendMessage_(hwnd, #EM_LINELENGTH, 0, 0) - (ende-start)
             If *this\txtlg + Len(GetClipboardText()) > *this\maxchar
                 IcStringGadget_BallonTip(hWnd, "eingefgter Text zu lang", 3)
             EndIf
         EndIf
  
  ElseIf msg = #WM_SETFOCUS
         If *this\dezimal
            If *this\tformat
               *this\txt = GetGadgetText(*this\pbnr)               
               *this\txt = ReplaceString(*this\txt,*this\punkt,"")
               *this\txt = ReplaceString(*this\txt,*this\komma,*this\punkt) 
               SetGadgetText(*this\pbnr, *this\txt)
            EndIf
         EndIf
         If *this\selectall 
            SendMessage_(hwnd,#EM_SETSEL,0,-1)
         EndIf
            
  ElseIf msg = #WM_KILLFOCUS
         If *this\dezimal
            *this\txt = GetGadgetText(*this\pbnr)
            *this\txt = StrF(ValF(*this\txt),*this\dezimal)
            *this\txtlg = SendMessage_(hwnd, #EM_LINELENGTH, 0, 0)
            If *this\tformat
               *this\txtlg = 1+(*this\txtlg*2)
               buffer$ = Space(*this\txtlg)
               GetNumberFormat_(0,0,@*this\txt,@*this\nfmt,@buffer$,*this\txtlg) 
               *this\txt = Trim(buffer$)
            EndIf
            SetGadgetText(*this\pbnr, *this\txt)
            *this\txtlg = SendMessage_(hwnd, #EM_LINELENGTH, 0, 0)
            If *this\txtlg > *this\maxchar
               IcStringGadget_BallonTip(hWnd, "formatierte Zahl zu lang", 3)
               ProcedureReturn 0
            EndIf
         EndIf         
  EndIf 

ProcedureReturn CallWindowProc_(*this\oldproc, hWnd, Msg, wParam, lParam)
EndProcedure 

Procedure.i IcStringGadget(pbnr, x, y, br, hh, text$="", flag=0, typ=1) 
Static *mem
  If *mem = 0
     *mem = AllocateMemory(SizeOf(cStringGadget_intern)) 
  EndIf
   
  Protected *this.cStringGadget = AllocateMemory(SizeOf(cStringGadget)) 
  If Not *this: ProcedureReturn #Null: EndIf 
  
  *this\VTable_cStringGadget = ?VTable_cStringGadget 
  *this\mem = *mem
    
  *this\x  = x
  *this\y  = y
  *this\br = br
  *this\hh = hh

  *this\dezimal = 0
  *this\maxchar = 0
  *this\numbers = 0
  *this\infohelptext = "keine Hilfe vorhanden"
  
  *this\typ = typ
   
  Select typ
    Case 1: nr =   StringGadget(pbnr, x, y, br, hh, text$, flag|#WS_BORDER) 
    Case 2: nr =   OptionGadget(pbnr, x, y, br, hh, text$) 
    Case 3: nr = CheckBoxGadget(pbnr, x, y, br, hh, text$, flag) 
    Case 4: nr =     TextGadget(pbnr, x, y, br, hh, text$, flag|#SS_NOTIFY|#SS_CENTERIMAGE) 
    Default:nr =     TextGadget(pbnr, x, y, br, hh, text$, flag|#SS_SUNKEN|#SS_CENTERIMAGE) 
  EndSelect
    
  If pbnr = #PB_Any
     *this\pbnr = nr
     *this\idnr = GadgetID(*this\pbnr)
  Else
     *this\idnr = nr
     *this\pbnr = pbnr
  EndIf
    
  *this\oldproc = SetWindowLong_(*this\idnr, #GWL_WNDPROC, @IcStringGadget_SubClassPrc()) 
  SetWindowLong_(*this\idnr, #GWL_USERDATA, *this)
  
  ProcedureReturn *this 
EndProcedure 

Procedure.i IcStringGadget_PBnr(*this.cStringGadget)
  ProcedureReturn *this\pbnr
EndProcedure
Procedure.i IcStringGadget_IDnr(*this.cStringGadget)
  ProcedureReturn *this\idnr
EndProcedure
Procedure.i IcStringGadget_Dezimal(*this.cStringGadget, anz=0)
  *this\dezimal = anz
  *this\numbers = #True
  
  Select *this\dezimal
    Case 0: *this\infodezimal1 = "Sie haben keine Dezimalstelle definiert"  

    Case 1: *this\infodezimal1 = "Sie haben nur 1 Dezimalstelle definiert"  
            *this\infodezimal2 = "Sie haben schon einen Dezimalpunkt eingegeben"

    Default:*this\infodezimal1 = "Es sind " + Str(*this\dezimal) + " Dezimalstellen erlaubt"    
            *this\infodezimal2 = "Sie haben schon einen Dezimalpunkt eingegeben"
  EndSelect
  
EndProcedure
Procedure.i IcStringGadget_TFormat(*this.cStringGadget)
 ;mu nach Dezimal aufgerufen werden 
  *this\tformat = #True
  *this\komma = ","
  *this\punkt = "."
  
  *this\nfmt\NumDigits = *this\dezimal
  *this\nfmt\LeadingZero = 0 
  *this\nfmt\Grouping = 3
  *this\nfmt\lpDecimalSep = @*this\komma
  *this\nfmt\lpThousandSep = @*this\punkt
  *this\nfmt\NegativeOrder = 1
EndProcedure
Procedure.i IcStringGadget_MaxChar(*this.cStringGadget, anz)
  If anz < 1: anz = 1: EndIf
  SendMessage_(*this\idnr, #EM_LIMITTEXT, anz, 0)
  *this\maxchar = anz
EndProcedure
Procedure.i IcStringGadget_Release(*this.cStringGadget) 
  FreeMemory ( *this ) 
  ProcedureReturn #Null 
EndProcedure
Procedure.i IcStringGadget_SelectAll(*this.cStringGadget)
  *this\selectall = #True
  SendMessage_(*this\idnr,#EM_SETSEL,0,-1)
EndProcedure
Procedure.i IcStringGadget_CursorPos(*this.cStringGadget,posi)
  SendMessage_(*this\idnr,#EM_SETSEL,posi,posi)
EndProcedure
Procedure.i IcStringGadget_Helptext(*this.cStringGadget,txt.s)
  *this\infohelptext = txt
EndProcedure
Procedure.i IcStringGadget_Textfeld(*this.cStringGadget,txt.s,br=0,flag=2)
  If Not IsGadget(*this\pbnr): ProcedureReturn: EndIf
  
  x  = *this\x 
  y  = *this\y   ; + 3  ;+3 nur ohne #SS_CENTERIMAGE
  hh =  *this\hh ; - 2
  If br = 0: br = *this\br: EndIf
  
  ResizeGadget(*this\pbnr, *this\x+br+5, #PB_Ignore, #PB_Ignore, #PB_Ignore)
  
  flag | #SS_WORDELLIPSIS | #SS_CENTERIMAGE
  TextGadget(#PB_Any, x, y, br, hh, txt, flag) 
    
EndProcedure
Procedure.i IcStringGadget_X(*this.cStringGadget)
  ProcedureReturn *this\x
EndProcedure
Procedure.i IcStringGadget_Y(*this.cStringGadget)
  ProcedureReturn *this\y
EndProcedure
Procedure.i IcStringGadget_NextX(*this.cStringGadget)
  ProcedureReturn GadgetX(*this\pbnr) + GadgetWidth(*this\pbnr) + 10
EndProcedure
Procedure.i IcStringGadget_NextY(*this.cStringGadget)
  ProcedureReturn GadgetY(*this\pbnr) + GadgetHeight(*this\pbnr) + 10
EndProcedure
Procedure.i IcStringGadget_IsLast(*this.cStringGadget,id)
;kennzeichnet ein IC als zuletzt definiertes
;ersetzt die -1 im Aufruf
  *this\mem\last = id
EndProcedure
Procedure.i IcStringGadget_IsFirst(*this.cStringGadget,id)
  *this\mem\first = id
EndProcedure
 
Procedure.s IcStringGadget_getText(*this.cStringGadget)
  *this\txt = GetGadgetText(*this\pbnr)
  ProcedureReturn *this\txt
EndProcedure
Procedure.i IcStringGadget_setFont(*this.cStringGadget,nr)
  SetGadgetFont(*this\pbnr,FontID(nr))
EndProcedure
Procedure.i IcStringGadget_setFrontColor(*this.cStringGadget,farbe)
  SetGadgetColor(*this\pbnr,#PB_Gadget_FrontColor, farbe)
EndProcedure
Procedure.i IcStringGadget_setBackColor(*this.cStringGadget,farbe)
  SetGadgetColor(*this\pbnr,#PB_Gadget_BackColor, farbe)
EndProcedure
Procedure.i IcStringGadget_setFocus(*this.cStringGadget)
  SetActiveGadget(*this\pbnr)
EndProcedure

DataSection 
VTable_cStringGadget: 
  Data.i @ IcStringGadget_Release() 
  Data.i @ IcStringGadget_PBnr()
  Data.i @ IcStringGadget_IDnr()
  Data.i @ IcStringGadget_Dezimal()
  Data.i @ IcStringGadget_TFormat()
  Data.i @ IcStringGadget_MaxChar()
  Data.i @ IcStringGadget_Helptext() 
  Data.i @ IcStringGadget_SelectAll()
  Data.i @ IcStringGadget_Textfeld()
  Data.i @ IcStringGadget_X()
  Data.i @ IcStringGadget_Y()
  Data.i @ IcStringGadget_NextX()
  Data.i @ IcStringGadget_NextY()
  Data.i @ IcStringGadget_CursorPos()
  Data.i @ IcStringGadget_IsLast()
  Data.i @ IcStringGadget_IsFirst()
  
  Data.i @ IcStringGadget_SubClassPrc()
    
  Data.i @ IcStringGadget_getText()
  Data.i @ IcStringGadget_setFont()
  Data.i @ IcStringGadget_setFocus()
  Data.i @ IcStringGadget_setFrontColor()
  Data.i @ IcStringGadget_setBackColor()
EndDataSection 

;Flags
;alle #PB_String_ ???
;#PB_Text_Right, #PB_Text_Center
;#WS_BORDER, #WS_THICKFRAME
 
;==============================================

;GetCurrencyFormat 
;GetNumberFormat 

; The current formatting rules are (borrowed from MS  ) 
; 0 - Digit (0 - 9) 
; 9 - Digit Or Space 
; L - Letter (A To Z, a To z) 
; ? - Letter Or Space 
; A - Letter Or Digit 
; a - Letter Or Digit Or Space 
; & - Any Character (displayable) 
; C - Any Character Or Space 
; > - This will cause the Next character To be capitalized 
; < - This will cause the Next character To be decapitalized 
; \ - This will cause the Next character To be displayed As a display character. 
; 



; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; FirstLine = 34
; Folding = GAxB-
; Markers = 429
; EnableXP